LLVM::Type - Crystal 1.20.2

# struct LLVM::Type

- LLVM::Type
- Struct
- Value
- Object

##
Defined in:

llvm/enums.cr
llvm/type.cr

##
Constructors

- .function(arg_types : Array(LLVM::Type), return_type, varargs = false) : self
- .new(unwrap : LibLLVM::TypeRef)

##
Instance Method Summary

- #alignment
- #array(count) : LLVM::Type
- #array_size : Int32
- #const_array(values : Array(LLVM::Value)) : Value
- #const_data_array(buffer : Bytes) : Value
- #const_double(value : Float64) : Value
- #const_double(string : String) : Value
- #const_float(value : Float32) : Value
- #const_float(value : String) : Value
- #const_int(value) : Value
- #context : Context
- #element_type : LLVM::Type
- #inline_asm(asm_string, constraints, has_side_effects = false, is_align_stack = false, can_throw = false, dialect : InlineAsmDialect = InlineAsmDialect::ATT)
- #inspect(io : IO) : Nil

  Appends this struct's name and instance variables names and values to the given IO.

- #int_width : Int32
- #kind : LLVM::Type::Kind
- #null
- #null_pointer
- #packed_struct? : Bool
- #params_size
- #params_types
- #pointer(address_space = 0) : LLVM::Type
- #return_type
- #size
- #struct_element_types : Array(LLVM::Type)
- #struct_name : String | Nil

  Assuming this type is a struct, returns its name.

- #to_unsafe : LibLLVM::TypeRef
- #undef
- #unwrap : LibLLVM::TypeRef
- #varargs?
- #vector(count) : self
- #vector_size
- #void?

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.function(arg_types : Array(LLVM::Type), return_type, varargs = false) : self #
def self.new(unwrap : LibLLVM::TypeRef) #

##
Instance Method Detail

def alignment #
def array(count) : LLVM::Type #
def array_size : Int32 #
def const_array(values : Array(LLVM::Value)) : Value #
def const_data_array(buffer : Bytes) : Value #
def const_double(value : Float64) : Value #
def const_double(string : String) : Value #
def const_float(value : Float32) : Value #
def const_float(value : String) : Value #
def const_int(value) : Value #
def context : Context #
def element_type : LLVM::Type #
def inline_asm(asm_string, constraints, has_side_effects = false, is_align_stack = false, can_throw = false, dialect : InlineAsmDialect = InlineAsmDialect::ATT) #
def inspect(io : IO) : Nil #
Description copied from struct Struct

Appends this struct's name and instance variables names and values to the given IO.

    struct Point
      def initialize(@x : Int32, @y : Int32)
      end
    end

    p1 = Point.new 1, 2
    p1.to_s    # "Point(@x=1, @y=2)"
    p1.inspect # "Point(@x=1, @y=2)"

def int_width : Int32 #
def kind : LLVM::Type::Kind #
def null #
def null_pointer #
def packed_struct? : Bool #
def params_size #
def params_types #
def pointer(address_space = 0) : LLVM::Type #
def return_type #
def size #
def struct_element_types : Array(LLVM::Type) #
def struct_name : String | Nil #

Assuming this type is a struct, returns its name. The name can be `nil` if the struct is anonymous. Raises if this type is not a struct.

def to_unsafe : LibLLVM::TypeRef #
def undef #
def unwrap : LibLLVM::TypeRef #
def varargs? #
def vector(count) : self #
def vector_size #
def void? #